import glob
import string
import nltk

IA_RAW_DATA_DIR = '../Data/Implicit Aspects Annotated/'
POSITIVE_WORDS_FILE = '../../../../Resources/Opinion Mining/Lexicon/positive-words.txt'
NEGATIVE_WORDS_FILE = '../../../../Resources/Opinion Mining/Lexicon/negative-words.txt'


def MakeGenericWordList(FileName, List):
    f=open(FileName,'r')
    word = f.readline()
    while word != '':
        word = word.rstrip('\n').rstrip('\r')
        if not word in List:
            List.append(word)
        word = f.readline()    
    return

if __name__ == '__main__':
    NegWordList = list()
    PosWordList = list()
    
    MakeGenericWordList(POSITIVE_WORDS_FILE, PosWordList)
    MakeGenericWordList(NEGATIVE_WORDS_FILE, NegWordList)
    
    DocList = glob.glob(IA_RAW_DATA_DIR + '*')
    
    t_p = 0
    f_p = 0
    t_n = 0
    f_n = 0
    
    for doc in DocList:
        SentencesNum = 0
        ImplicitSentencesNum = 0
        Words = 0
        ImplicitWords = { }
        WordTypes = [] 
       
        f = open(doc, 'r')
        txt = f.readline()
        while txt != '':
            if '[t]' in txt:
                txt = f.readline()
                continue
            
            split = txt.split('##')
            sentence_wo_punct = split[1].translate(string.maketrans("",""), string.punctuation)
            tokens = nltk.word_tokenize(sentence_wo_punct)
            
            if split[0] == '':
                for token in tokens:
                    if token in PosWordList or token in NegWordList:
                        f_p += 1
                    else:
                        t_n += 1
            else:
                for iai_aspect in split[0].split(','):
                    IAI = iai_aspect.split('[')[0]
                    IAI = IAI.strip(' ')
                    if IAI != '':
                        if IAI in PosWordList or IAI in NegWordList:
                            t_p += 1
                        else:
                            f_n += 1
                for token in tokens:
                    if token in PosWordList or token in NegWordList:
                        f_p += 1
                    else:
                        t_n += 1

            
            txt = f.readline()
        f.close()
            
    P = float(float(t_p)/(float(t_p) + float(f_p)))
    R = float(float(t_p)/(float(t_p) + float(f_n)))
    F1 = float(2 * (P * R)/(P + R))

    
    print "Precision: " + str(P)
    print "Recall: " + str(R)
    print "F1: " + str(F1)  
    
    
    